
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x,y,x0,y0,x1,y1,x2,y2,x3,y3,x21,y21,dx,dy,t,dt,r,w,ct,c1,c2,c4,c3;
let i,f1,strobo;
let sx=[];
let sy=[];
let sx1=[];
let sy1=[];
let sx2=[];
let sy2=[];
let sx3=[];
let sy3=[];
let d = { width: canvas.width, height: canvas.height };


function init() {
	        x=d.width/8;
			y=d.height/2;
			x0=d.width/8;
			y0=d.height/2;
			dx=1;
			t=0;
			strobo=1;
	        f1=1;
			r=d.height/4;
		    dt=1;
			w=dx/r;
			ct=0;
			c1=0;c2=0;c3=1;c4=0;
         buffer = createBuffer(d.width, d.height);
         drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
        const g = buffer.getContext("2d");
			g.fillStyle = "white";
		    g.fillRect(0,0,d.width,d.height);
				
		g.strokeStyle="gray"; //車輪
		g.beginPath();
        g.arc(x,y,3*r/2, 0, Math.PI * 2);
		g.stroke();		
		
		g.strokeStyle="gray"; 
		g.beginPath();
        g.arc(x,y,r, 0, Math.PI * 2);
		g.stroke();	
		
		g.strokeStyle="gray"; 
		g.beginPath();
        g.arc(x,y,r/2, 0, Math.PI * 2);
		g.stroke();
		
		g.strokeStyle="gray"; 
		g.beginPath();
        g.arc(x,y,r/8, 0, Math.PI * 2);
		g.stroke();
		
		g.strokeStyle="gray";//水平線
		g.beginPath();
		g.moveTo(0,3*d.height/4);
        g.lineTo(d.width,3*d.height/4);
		g.stroke();
				
		
		g.strokeStyle="gray";//spike
		g.beginPath();
		g.moveTo(x,y);
        g.lineTo(x3,y3);
		g.stroke();		
		
		g.fillStyle="blue";//車軸
		g.beginPath();
		g.arc(x,y,2, 0, Math.PI * 2);
        g.fill();
		
		if(strobo==1){
		if(c1==1){
		//strobo 半径r/8の車輪上の点
		for(i=0;i<ct;i++){
		g.fillStyle="green";	
		g.fillRect(sx[i],sy[i],2, 2);
		}
		}
        
        if(c2==1){	
		//strobo 半径r/2
		for(i=0;i<ct;i++){
		g.fillStyle="magenta";	
		g.fillRect(sx2[i],sy2[i],2, 2);
		}
        }
		if(c3==1){			
		//strobo 半径r
		for(i=0;i<ct;i++){
		g.fillStyle="blue";	
		g.fillRect(sx1[i],sy1[i],2, 2);	
		}
		}
		
		if(c4==1){
		//strobo 半径3r/2
		for(i=0;i<ct;i++){
		g.fillStyle="cyan";	
		g.fillRect(sx3[i],sy3[i],2, 2);	
		}
        }		
		}
		 
		/* 
		g.fillStyle="brue";//strobo===0
		g.beginPath();
		g.arc(x21,y21,2, 0, Math.PI * 2);
        g.fill();
		g.fillStyle="brue";
		g.beginPath();
		g.arc(x1,y1,2, 0, Math.PI * 2);
        g.fill();
		g.fillStyle="blue";
		g.beginPath();
		g.arc(x2,y2,2, 0, Math.PI * 2);
        g.fill();
		g.fillStyle="blue";
		g.beginPath();
		g.arc(x3,y3,2, 0, Math.PI * 2);
        g.fill();*/			
			   	
}

function move() {
            let bx,by;
			bx=x;
			by=y;
			
			x=x+dx*f1;
			//y=y+dy*f1;
			x1=bx-r*Math.sin(w*t);
			y1=by+r*Math.cos(w*t);
			x21=bx-(r/8)*Math.sin(w*t);
			y21=by+(r/8)*Math.cos(w*t);
			x2=bx-(r/2)*Math.sin(w*t);
			y2=by+(r/2)*Math.cos(w*t);
			x3=bx-(3*r/2)*Math.sin(w*t);
			y3=by+(3*r/2)*Math.cos(w*t);
			t=t+dt*f1;
			
			for(i=0;i<ct;i++){  //strobo 
			//sx[i]=x0+i*dx;
			sx[i]=x0+i*dx-(r/8)*Math.sin(w*i*dt);
			sy[i]=y0+(r/8)*Math.cos(w*i*dt);
			sx1[i]=x0+i*dx-r*Math.sin(w*i*dt);
			sy1[i]=y0+r*Math.cos(w*i*dt);
			sx2[i]=x0+i*dx-(r/2)*Math.sin(w*i*dt);
			sy2[i]=y0+(r/2)*Math.cos(w*i*dt);
			sx3[i]=x0+i*dx-(3*r/2)*Math.sin(w*i*dt);
			sy3[i]=y0+(3*r/2)*Math.cos(w*i*dt);
			
			}
			ct=ct+1*f1;
			if(x>=d.width+r){
				
				f1=0;
				
			}
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
		ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
}


document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Curve1').addEventListener('click', Curve1);
document.getElementById('Curve2').addEventListener('click', Curve2);
document.getElementById('Curve3').addEventListener('click', Curve3);
document.getElementById('Curve4').addEventListener('click', Curve4);
document.getElementById('Stop').addEventListener('click', Stop);
document.getElementById('Reset').addEventListener('click', Reset);


function Run() {
       f1=1;strobo=0;
			
}
function Curve1() {
       strobo=1;f1=1;c1=1;	
						
}
function Curve2() {
       strobo=1;f1=1;c2=1;	
						
}
function Curve3() {
       strobo=1;f1=1;c3=1;	
						
}
function Curve4() {
       strobo=1;f1=1;c4=1;	
						
}
function Stop() {
       f1=0;					
						
}
function Reset() {
        f1=0;strobo=0;t=0;ct=0;c1=0;c2=0;c3=0;c4=0;
			x=d.width/8;
			y=d.height/2;
			g.fillStyle = "white";
		    g.fillRect(0,0,d.width,d.height);
}


init();
start();




